#pragma once

#include "CritSection.h"
// ʹñصado;
#import "..\ado\msado15.dll" no_namespace rename("EOF", "EndOfFile") 

class CMESdb
{
	CMESdb(void);
public:
	static CMESdb* GetInstance()
	{
		static ThreadSection _mutex;
		static CMESdb *pInstatnce = NULL;		
		_mutex.Lock();
		if (!pInstatnce)
		{
			if (NULL == pInstatnce)
			{
				static CMESdb obj;
				pInstatnce = &obj;
				::CoInitialize(NULL);
				pInstatnce->InitAdo();
				pInstatnce->InitAdo2();
				pInstatnce->InitAdo3();
			}
		}
		_mutex.Unlock();

		return pInstatnce;
	}

	~CMESdb();

	static TString ToString(_variant_t var);

private:
	ThreadSection m_ts;
	_ConnectionPtr m_pConnection;
	_ConnectionPtr m_pConnection2;
	_ConnectionPtr m_pConnection3;
	_ConnectionPtr m_pCurrConnection;
	_RecordsetPtr m_pRecordset;

public:
	bool InitAdo();
	bool InitAdo2();
	bool InitAdo3();
	void SetConnection(int nIndex=0){
		switch (nIndex)
		{
		case 0:
			m_pCurrConnection = m_pConnection;
			break;
		case 1:
			m_pCurrConnection = m_pConnection2;
			break;
		case 2:
			m_pCurrConnection = m_pConnection3;
			break;
		default:
			break;
		}
	}
	bool Query(TString strSQL, std::map<TString, TString> &data);

	// ȡߴ;
	bool GetProcessCode(TString &data, TString strProcessName=_T("ƽ"));
	// ȡվ;
	bool GetCompanyCode(TString &data, TString strCompanyName);
	//TVSNǷ
	bool IsExitTVSN(TString TVSN);
	//TVSNʱĹڵ
	bool GetNextProcessCode(TString TVSN, TString &data);
	//ɨ赱ǰĹվվɨ裩
	bool Scan(
		TString TVSN,
		TString LineCode,             //ߴ
		TString PcProcessCode,		//վ룬36Ϊƽ⹤վڵ
		TString Host,                    //Ե
		TString IP,                        //ԵIPַ
		TString User,                    //PE
		TString UserName,           //PE
		TString PartStrs,               //Ϊ
		TString &ErroMsg);       //ش
	// ϴ;
	bool UploadTestData(TString strSN, TString strResult, TString strDateTime);
	bool GetWhiteid(TString strBom, TString &Whiteid);
	bool GetWhiteValue(TString strWhiteid, TString strWhiteName,TString &strValue);
	// ȡDeltaE;
	bool GetDeltaEInfo(TString strBatch, TString &strDeltaEType, TString &strDeltaValue);
};
